﻿#include "Directry.ch"
#include "hmg.ch"
#include "PdfView.ch"

STATIC lPdfView_Max
STATIC nPdfView_R
STATIC nPdfView_C
STATIC nPdfView_W
STATIC nPdfView_H
STATIC nFiles_W
STATIC lBookmarks
STATIC lToolbar
STATIC lOpenAtOnce
STATIC lEscExit
STATIC cSumatraDir
STATIC cFileDir
STATIC cFileLast
STATIC cLang

STATIC cPanel
STATIC lMenuActive
STATIC nHFocusMenu

MEMVAR _HMG_SYSDATA
MEMVAR _HMG_DEFAULTICONNAME


FUNCTION Main()

  SET FONT TO "MS Shell Dlg", 8
  SET DEFAULT ICON TO "SUMATRA"

  SettingsRead()

  IF IsProgramRunning()
    QUIT
  ENDIF

  cPanel      := "SumatraPanel"
  lMenuActive := .F.

  DEFINE WINDOW PdfView;
    ROW    nPdfView_R;
    COL    nPdfView_C;
    WIDTH  nPdfView_W;
    HEIGHT nPdfView_H;
    TITLE  "PdfView";
    MAIN;
    ON INIT      FileListRefresh(cFileLast);
    ON GOTFOCUS  PdfView.PdfTimer.ENABLED := .T.;
    ON LOSTFOCUS PdfView.PdfTimer.ENABLED := .F.;
    ON SIZE      ResizeControls();
    ON MAXIMIZE  ResizeControls();
    ON RELEASE   (SettingsWrite(), Sumatra_FileClose(cPanel))

    DEFINE GRID Files
      ROW            0
      COL            0
      WIDTH          nFiles_W
      HEADERS        {NIL, NIL, NIL, NIL, NIL}
      WIDTHS         {nFiles_W - 4, 0, 0, 0, 0}
      CELLNAVIGATION .F.
      ONDBLCLICK     FileOpen()
      ONCHANGE       If(lOpenAtOnce .and. (! ("D" $ PdfView.Files.CellEx(PdfView.Files.VALUE, F_ATTR))), FileOpen(), NIL)
      ONKEY          GridOnKey()
    END GRID

    DEFINE WINDOW &(cPanel);
      PANEL;
      ON PAINT Sumatra_FrameRedraw(cPanel)
    END WINDOW

    DEFINE STATUSBAR
      STATUSITEM ""
      STATUSITEM "" WIDTH 120
    END STATUSBAR

    DEFINE TIMER PdfTimer;
      INTERVAL 100;
      ACTION   SetStatusPage()

    DEFINE MAINMENU
      DEFINE POPUP "&File"
        MENUITEM "Open"                    NAME FileOpen       ACTION FileOpen()
        MENUITEM "Open at page..."         NAME FileOpenAt     ACTION FileOpen(.T.)
        MENUITEM e"Close\tCtrl+W"          NAME FileClose      ACTION FileClose()
        SEPARATOR
        MENUITEM e"Save as...\tCtrl+S"     NAME FileSaveAs     ACTION Sumatra_FileSaveAs(cPanel)
        MENUITEM e"Print...\tCtrl+P"       NAME FilePrint      ACTION Sumatra_FilePrint(cPanel)
        MENUITEM e"Properties\tCtrl+D"     NAME FileProperties ACTION Sumatra_FileProperties(cPanel)
        SEPARATOR
        MENUITEM e"Refresh list\tF5 (F9)"  NAME FileRefresh    ACTION FileListRefresh(PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME))
        SEPARATOR
        MENUITEM e"Exit\tAlt+F4"           NAME AppExit        ACTION ThisWindow.RELEASE
      END POPUP
      DEFINE POPUP "&Page"
        MENUITEM e"Go to...\tCtrl+G"       NAME PageGoTo       ACTION Sumatra_PageGoTo(cPanel)
        SEPARATOR
        MENUITEM "Previous"                NAME PagePrev       ACTION Sumatra_PageGoTo(cPanel, -1)
        MENUITEM "Next"                    NAME PageNext       ACTION Sumatra_PageGoTo(cPanel,  1)
        MENUITEM "First"                   NAME PageFirst      ACTION Sumatra_PageGoTo(cPanel, -2)
        MENUITEM "Last"                    NAME PageLast       ACTION Sumatra_PageGoTo(cPanel,  2)
      END POPUP
      DEFINE POPUP "&Find"
        MENUITEM e"Text...\tCtrl+F"        NAME FindText       ACTION Sumatra_FindText(cPanel)
        SEPARATOR
        MENUITEM e"Previous\tShift+F3"     NAME FindPrev       ACTION Sumatra_FindText(cPanel, -1)
        MENUITEM e"Next\tF3"               NAME FindNext       ACTION Sumatra_FindText(cPanel,  1)
      END POPUP
      DEFINE POPUP "&Zoom"
        MENUITEM e"Size down\tCtrl+Minus"  NAME SizeDown       ACTION Sumatra_Zoom(cPanel, -1)
        MENUITEM e"Size up\tCtrl+Plus"     NAME SizeUp         ACTION Sumatra_Zoom(cPanel,  1)
        SEPARATOR
        MENUITEM e"Fit page\tCtrl+0"       NAME FitPage        ACTION Sumatra_Zoom(cPanel, 2)
        MENUITEM e"Real size\tCtrl+1"      NAME SizeReal       ACTION Sumatra_Zoom(cPanel, 3)
        MENUITEM e"Fit width\tCtrl+2"      NAME FitWidth       ACTION Sumatra_Zoom(cPanel, 4)
        SEPARATOR
        MENUITEM e"Zoom factor...\tCtrl+Y" NAME ZoomFactor     ACTION Sumatra_Zoom(cPanel)
      END POPUP
      DEFINE POPUP "&Rotate"
        MENUITEM e"Left\tCtrl+Shift+Minus" NAME RotateLeft     ACTION Sumatra_Rotate(cPanel, -1)
        MENUITEM e"Right\tCtrl+Shift+Plus" NAME RotateRight    ACTION Sumatra_Rotate(cPanel,  1)
        MENUITEM e"180°\tCtrl+Shift+Num*"  NAME Rotate180      ACTION Sumatra_Rotate(cPanel)
      END POPUP
      DEFINE POPUP "&Settings"
        MENUITEM e"Bookmarks\tF12"         NAME Bookmarks      ACTION Sumatra_Bookmarks(cPanel, ! Sumatra_Bookmarks(cPanel))
        MENUITEM e"Toolbar\tF8"            NAME Toolbar        ACTION Sumatra_Toolbar(cPanel, ! Sumatra_Toolbar(cPanel))
        SEPARATOR
        MENUITEM "Open pdf at once"        NAME OpenAtOnce     ACTION (lOpenAtOnce := ! lOpenAtOnce)
        MENUITEM "Esc - exit program"      NAME EscExit        ACTION ((lEscExit := ! lEscExit), SetOnKey(.T.))
        MENUITEM "SumatraPDF directory"    NAME SumatraDir     ACTION InputSumatraDir()
      END POPUP
    END MENU
  END WINDOW

  ListView_ChangeExtendedStyle(PdfView.Files.HANDLE, LVS_EX_INFOTIP)
  HMG_ChangeWindowStyle(GetFormHandle(cPanel), WS_SIZEBOX, NIL, .F., .T.)

  IF lPdfView_Max
    PdfView.MAXIMIZE
  ENDIF

  ResizeControls()
  SetOnKey(.T.)
//  SetLang()
  InstallEventHandler("EventHandler")

  PdfView.ACTIVATE

RETURN NIL


FUNCTION EventHandler(nHWnd, nMsg, nWParam, nLParam)
  LOCAL nMaxY
  LOCAL aRect1, aRect2
  LOCAL nCol

  IF nHWnd == PdfView.HANDLE
    SWITCH nMsg
      CASE 36 /*WM_GETMINMAXINFO*/
        SetMinMaxTrackSize(nLParam, 400, 300)
        EXIT

      CASE 274 /*WM_SYSCOMMAND*/
        IF HB_BitAnd(nWParam, 0xFFF0) == 0xF100 /*SC_KEYMENU*/
          PdfView.PdfTimer.ENABLED := .F.
          //for Win-10
          IF GetFocus() != PdfView.Files.HANDLE
            nHFocusMenu := GetFocus()
            PdfView.Files.SETFOCUS
            PostMessage(nHWnd, nMsg, nWParam, nLParam)
            RETURN 1
          ENDIF
        ENDIF
        RETURN 0

      CASE 278 /*WM_INITMENU*/
        lMenuActive := .T.
        EnableCommands()
        SetOnKey(.F.)
        RETURN 0

      CASE 530 /*WM_EXITMENULOOP*/
        lMenuActive := .F.
        SetOnKey(.T.)

        //for Win-10
        IF IsWindowEnabled(nHFocusMenu)
          SetFocus(nHFocusMenu)
          nHFocusMenu := NIL
        ENDIF

        PdfView.PdfTimer.ENABLED := .T.
        RETURN 0
    ENDSWITCH

  ELSEIF _IsWindowDefined(cPanel) .and. (nHWnd == GetFormHandle(cPanel))
    SWITCH nMsg
      CASE 36 /*WM_GETMINMAXINFO*/
        nMaxY := PdfView.CLIENTAREAHEIGHT - GetWindowHeight(PdfView.STATUSBAR.HANDLE)
        SetMinMaxTrackSize(nLParam, 200, nMaxY, PdfView.CLIENTAREAWIDTH - 100, nMaxY)
        EXIT

      CASE 532 /*WM_SIZING*/
        aRect1 := Array(4)
        aRect2 := Array(4)

        GetWindowRect(GetFormHandle(cPanel), aRect1)
        GetRectArray(nLParam, aRect2)

        SWITCH nWParam
          CASE 1 /*WMSZ_LEFT*/
          CASE 4 /*WMSZ_TOPLEFT*/
          CASE 7 /*WMSZ_BOTTOMLEFT*/
            IF aRect1[1] != aRect2[1]
              nCol := ScreenToClientCol(PdfView.HANDLE, aRect2[1])
              PdfView.Files.WIDTH := nCol
              PdfView.Files.ColumnWIDTH(1) := nCol - 4 - If(PdfView.Files.ITEMCOUNT > SendMessage(PdfView.Files.HANDLE, 0x1028 /*LVM_GETCOUNTPERPAGE*/, 0, 0), GetVScrollBarWidth(), 0)
              SetProperty(cPanel, "WIDTH", PdfView.CLIENTAREAWIDTH - nCol + (GetProperty(cPanel, "WIDTH") - GetProperty(cPanel, "CLIENTAREAWIDTH")) / 2)
              Sumatra_FrameAdjust(cPanel)
            ENDIF
            EXIT
          OTHERWISE
            SetRectArray(nLParam, aRect1)
        ENDSWITCH
        EXIT
    ENDSWITCH
  ENDIF

RETURN NIL


FUNCTION SetOnKey(lSet)

  IF lSet
    ON KEY TAB                    OF PdfView ACTION SetFocusNextCtl(.F.)
    ON KEY SHIFT+TAB              OF PdfView ACTION SetFocusNextCtl(.T.)
    ON KEY CONTROL+TAB            OF PdfView ACTION NIL
    ON KEY CONTROL+W              OF PdfView ACTION FileClose()
    ON KEY CONTROL+S              OF PdfView ACTION Sumatra_FileSaveAs(cPanel)
    ON KEY CONTROL+P              OF PdfView ACTION Sumatra_FilePrint(cPanel)
    ON KEY CONTROL+D              OF PdfView ACTION Sumatra_FileProperties(cPanel)
    ON KEY F5                     OF PdfView ACTION FileListRefresh(PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME))
    ON KEY F9                     OF PdfView ACTION FileListRefresh(PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME))
    ON KEY CONTROL+G              OF PdfView ACTION Sumatra_PageGoTo(cPanel)
    ON KEY CONTROL+F              OF PdfView ACTION Sumatra_FindText(cPanel)
    ON KEY SHIFT+F3               OF PdfView ACTION Sumatra_FindText(cPanel, -1)
    ON KEY F3                     OF PdfView ACTION Sumatra_FindText(cPanel,  1)
    ON KEY CONTROL+MINUS          OF PdfView ACTION Sumatra_Zoom(cPanel, -1)
    ON KEY CONTROL+SUBTRACT       OF PdfView ACTION Sumatra_Zoom(cPanel, -1)
    ON KEY CONTROL+PLUS           OF PdfView ACTION Sumatra_Zoom(cPanel,  1)
    ON KEY CONTROL+ADD            OF PdfView ACTION Sumatra_Zoom(cPanel,  1)
    ON KEY CONTROL+0              OF PdfView ACTION Sumatra_Zoom(cPanel,  2)
    ON KEY CONTROL+NUMPAD0        OF PdfView ACTION Sumatra_Zoom(cPanel,  2)
    ON KEY CONTROL+1              OF PdfView ACTION Sumatra_Zoom(cPanel,  3)
    ON KEY CONTROL+NUMPAD1        OF PdfView ACTION Sumatra_Zoom(cPanel,  3)
    ON KEY CONTROL+2              OF PdfView ACTION Sumatra_Zoom(cPanel,  4)
    ON KEY CONTROL+NUMPAD2        OF PdfView ACTION Sumatra_Zoom(cPanel,  4)
    ON KEY CONTROL+7              OF PdfView ACTION NIL
    ON KEY CONTROL+NUMPAD7        OF PdfView ACTION NIL
    ON KEY CONTROL+8              OF PdfView ACTION NIL
    ON KEY CONTROL+NUMPAD8        OF PdfView ACTION NIL
    ON KEY CONTROL+Y              OF PdfView ACTION Sumatra_Zoom(cPanel)
    ON KEY CONTROL+SHIFT+MINUS    OF PdfView ACTION Sumatra_Rotate(cPanel, -1)
    ON KEY CONTROL+SHIFT+SUBTRACT OF PdfView ACTION Sumatra_Rotate(cPanel, -1)
    ON KEY CONTROL+SHIFT+PLUS     OF PdfView ACTION Sumatra_Rotate(cPanel,  1)
    ON KEY CONTROL+SHIFT+ADD      OF PdfView ACTION Sumatra_Rotate(cPanel,  1)
    ON KEY CONTROL+SHIFT+MULTIPLY OF PdfView ACTION Sumatra_Rotate(cPanel)
    ON KEY CONTROL+SHIFT+DIVIDE   OF PdfView ACTION Sumatra_Rotate(cPanel)
    ON KEY F8                     OF PdfView ACTION Sumatra_Toolbar(cPanel, ! Sumatra_Toolbar(cPanel))
    ON KEY ALT+RETURN             OF PdfView ACTION If(IsMaximized(PdfView.HANDLE), PdfView.RESTORE, PdfView.MAXIMIZE)

    IF lEscExit
      ON KEY ESCAPE      OF PdfView ACTION PdfView.RELEASE
    ELSE
      RELEASE KEY ESCAPE OF PdfView
    ENDIF
  ELSE
    RELEASE KEY TAB                    OF PdfView
    RELEASE KEY SHIFT+TAB              OF PdfView
    RELEASE KEY CONTROL+TAB            OF PdfView
    RELEASE KEY CONTROL+W              OF PdfView
    RELEASE KEY CONTROL+S              OF PdfView
    RELEASE KEY CONTROL+P              OF PdfView
    RELEASE KEY CONTROL+D              OF PdfView
    RELEASE KEY F5                     OF PdfView
    RELEASE KEY F9                     OF PdfView
    RELEASE KEY CONTROL+G              OF PdfView
    RELEASE KEY CONTROL+F              OF PdfView
    RELEASE KEY SHIFT+F3               OF PdfView
    RELEASE KEY F3                     OF PdfView
    RELEASE KEY CONTROL+MINUS          OF PdfView
    RELEASE KEY CONTROL+SUBTRACT       OF PdfView
    RELEASE KEY CONTROL+PLUS           OF PdfView
    RELEASE KEY CONTROL+ADD            OF PdfView
    RELEASE KEY CONTROL+0              OF PdfView
    RELEASE KEY CONTROL+NUMPAD0        OF PdfView
    RELEASE KEY CONTROL+1              OF PdfView
    RELEASE KEY CONTROL+NUMPAD1        OF PdfView
    RELEASE KEY CONTROL+2              OF PdfView
    RELEASE KEY CONTROL+NUMPAD2        OF PdfView
    RELEASE KEY CONTROL+7              OF PdfView
    RELEASE KEY CONTROL+NUMPAD7        OF PdfView
    RELEASE KEY CONTROL+8              OF PdfView
    RELEASE KEY CONTROL+NUMPAD8        OF PdfView
    RELEASE KEY CONTROL+Y              OF PdfView
    RELEASE KEY CONTROL+SHIFT+MINUS    OF PdfView
    RELEASE KEY CONTROL+SHIFT+SUBTRACT OF PdfView
    RELEASE KEY CONTROL+SHIFT+PLUS     OF PdfView
    RELEASE KEY CONTROL+SHIFT+ADD      OF PdfView
    RELEASE KEY CONTROL+SHIFT+MULTIPLY OF PdfView
    RELEASE KEY CONTROL+SHIFT+DIVIDE   OF PdfView
    RELEASE KEY F8                     OF PdfView
    RELEASE KEY ALT+RETURN             OF PdfView
    RELEASE KEY ESCAPE                 OF PdfView
  ENDIF

RETURN NIL


FUNCTION GridOnKey()

  IF ! lMenuActive
    SWITCH HMG_GetLastVirtualKeyDown()
      CASE VK_F12
        HMG_CleanLastVirtualKeyDown()

        IF (GetKeyState(VK_CONTROL) >= 0) .and. (GetKeyState(VK_SHIFT) >= 0) .and. (GetKeyState(VK_MENU) >= 0)
          Sumatra_Bookmarks(cPanel, ! Sumatra_Bookmarks(cPanel))
          PdfView.Files.SETFOCUS
        ENDIF
        EXIT
      CASE VK_LEFT
        HMG_CleanLastVirtualKeyDown()

        IF (GetKeyState(VK_CONTROL) >= 0) .and. (GetKeyState(VK_SHIFT) >= 0) .and. (GetKeyState(VK_MENU) >= 0) .and. (PdfView.Files.CellEx(1, F_NAME) == "<..>")
          PdfView.Files.VALUE := 1
          FileOpen()
        ENDIF
        EXIT
      CASE VK_RIGHT
        HMG_CleanLastVirtualKeyDown()

        IF (GetKeyState(VK_CONTROL) >= 0) .and. (GetKeyState(VK_SHIFT) >= 0) .and. (GetKeyState(VK_MENU) >= 0) .and. ("D" $ PdfView.Files.CellEx(PdfView.Files.VALUE, F_ATTR)) .and. (! (PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME) == "<..>"))
          FileOpen()
        ENDIF
        EXIT
    ENDSWITCH
  ENDIF

RETURN NIL


FUNCTION SetFocusNextCtl(lPrevious)
  LOCAL nHFocus := GetFocus()
  LOCAL nHFrame := Sumatra_FrameHandle(cPanel)
  LOCAL nHBook  := Sumatra_BookmarksHandle(cPanel)

  IF nHFrame != 0
    IF nHFocus == PdfView.Files.HANDLE
      SetFocus(If(lPrevious, nHFrame, If(Sumatra_Bookmarks(cPanel), nHBook, nHFrame)))
    ELSEIF nHFocus == nHBook
      SetFocus(If(lPrevious, PdfView.Files.HANDLE, nHFrame))
    ELSE
      SetFocus(If(lPrevious, If(Sumatra_Bookmarks(cPanel), nHBook, PdfView.Files.HANDLE), PdfView.Files.HANDLE))
    ENDIF
  ENDIF

RETURN NIL


FUNCTION ResizeControls()
  LOCAL nMainCW := PdfView.CLIENTAREAWIDTH
  LOCAL nMainCH := PdfView.CLIENTAREAHEIGHT - GetWindowHeight(PdfView.STATUSBAR.HANDLE)
  LOCAL nFilesW := PdfView.Files.WIDTH
  LOCAL nFrameW := (GetProperty(cPanel, "WIDTH") - GetProperty(cPanel, "CLIENTAREAWIDTH")) / 2

  IF (nMainCW - nFilesW) < (200 - nFrameW)
    nFilesW := nMainCW - 200 - nFrameW
    PdfView.Files.WIDTH := nFilesW
    PdfView.Files.ColumnWIDTH(1) := nFilesW - 4 - If(PdfView.Files.ITEMCOUNT > SendMessage(PdfView.Files.HANDLE, 0x1028 /*LVM_GETCOUNTPERPAGE*/, 0, 0), GetVScrollBarWidth(), 0)
  ENDIF

  PdfView.Files.HEIGHT := nMainCH
  SendMessage(PdfView.Files.HANDLE, 0x1013 /*LVM_ENSUREVISIBLE*/, PdfView.Files.VALUE - 1, 0)

  //bug in MHG: SetProperty(cPanel, "ROW", nRow), SetProperty(cPanel, "COL", nCol)
  //reported: http://www.hmgforum.com/viewtopic.php?f=20&t=5178
  SetProperty(cPanel, "COL", ClientToScreenCol(GetParent(GetFormHandle(cPanel)), nFilesW))
  SetProperty(cPanel, "WIDTH", nMainCW - nFilesW + nFrameW)
  SetProperty(cPanel, "HEIGHT", nMainCH)

  Sumatra_FrameAdjust(cPanel)

RETURN NIL


FUNCTION EnableCommands()
  LOCAL lPdfSelected := (PdfView.Files.VALUE > 0) .and. (! ("D" $ PdfView.Files.CellEx(PdfView.Files.VALUE, F_ATTR)))
  LOCAL lPdfOpened   := (Sumatra_FrameHandle(cPanel) != 0)
  LOCAL lPdfLoaded   := (lPdfOpened .and. (Sumatra_PageNumber(cPanel) > 0))
  LOCAL lBookExist   := Sumatra_BookmarksExist(cPanel)

  PdfView.FileOpen.ENABLED       := lPdfSelected
  PdfView.FileOpenAt.ENABLED     := lPdfSelected
  PdfView.FileClose.ENABLED      := lPdfOpened
  PdfView.FileSaveAs.ENABLED     := lPdfLoaded
  PdfView.FilePrint.ENABLED      := lPdfLoaded
  PdfView.FileProperties.ENABLED := lPdfLoaded
  PdfView.PageGoto.ENABLED       := lPdfLoaded
  PdfView.PagePrev.ENABLED       := lPdfLoaded
  PdfView.PageNext.ENABLED       := lPdfLoaded
  PdfView.PageFirst.ENABLED      := lPdfLoaded
  PdfView.PageLast.ENABLED       := lPdfLoaded
  PdfView.FindText.ENABLED       := lPdfLoaded
  PdfView.FindPrev.ENABLED       := lPdfLoaded
  PdfView.FindNext.ENABLED       := lPdfLoaded
  PdfView.SizeDown.ENABLED       := lPdfLoaded
  PdfView.SizeUp.ENABLED         := lPdfLoaded
  PdfView.FitPage.ENABLED        := lPdfLoaded
  PdfView.SizeReal.ENABLED       := lPdfLoaded
  PdfView.FitWidth.ENABLED       := lPdfLoaded
  PdfView.ZoomFactor.ENABLED     := lPdfLoaded
  PdfView.Rotate180.ENABLED      := lPdfLoaded
  PdfView.RotateLeft.ENABLED     := lPdfLoaded
  PdfView.RotateRight.ENABLED    := lPdfLoaded
  PdfView.Bookmarks.ENABLED      := lBookExist
  PdfView.Toolbar.ENABLED        := lPdfOpened

  PdfView.Bookmarks.CHECKED  := If(lBookExist, Sumatra_Bookmarks(cPanel), lBookmarks)
  PdfView.Toolbar.CHECKED    := If(lPdfOpened, Sumatra_Toolbar(cPanel),lToolbar)
  PdfView.OpenAtOnce.CHECKED := lOpenAtOnce
  PdfView.EscExit.CHECKED    := lEscExit

RETURN NIL


FUNCTION SetStatusPage()
  STATIC nPage   := 0
  STATIC nCount  := 0
  LOCAL  nPage1  := Sumatra_PageNumber(cPanel)
  LOCAL  nCount1 := Sumatra_PageCount(cPanel)

  IF (nPage != nPage1) .or. (nCount != nCount1)
    nPage  := nPage1
    nCount := nCount1

    PdfView.STATUSBAR.Item(2) := If(nCount == 0, "", "Page: " + HB_NtoS(nPage) + '/' + HB_NtoS(nCount))
  ENDIF

  RELEASE MEMORY

RETURN NIL


FUNCTION FileListRefresh(cFileSel)
  LOCAL nSel := 1
  LOCAL aFile
  LOCAL nLen
  LOCAL n

  EnableWindowRedraw(PdfView.Files.HANDLE, .F.)
  PdfView.Files.DELETEALLITEMS

  IF ! Empty(cFileDir)
    IF VolSerial(HB_ULeft(cFileDir, 3)) == -1
      cFileSel := HB_ULeft(cFileDir, 2)
      cFileDir := ""
    ELSE
      DO WHILE ! HB_DirExists(cFileDir)
        cFileSel := ""
        cFileDir := DirParent(cFileDir)
      ENDDO
    ENDIF
  ENDIF

  IF Empty(cFileDir)
    FOR n := 65 TO 90 //from "A" to "Z"
      IF IsDisk(Chr(n))
        PdfView.Files.AddItem({Chr(n) + ":", 0, "", "", "DK"})

        IF (Chr(n) + ":") == cFileSel
          nSel := PdfView.Files.ITEMCOUNT
        ENDIF
      ENDIF
    NEXT

  ELSE
    aFile := Directory(cFileDir + "*.*", "DHS")

    FOR n := Len(aFile) TO 1 STEP -1
      IF "D" $ aFile[n][F_ATTR]
        IF (aFile[n][F_NAME] == ".") .or. (aFile[n][F_NAME] == "..")
          HB_aDel(aFile, n, .T.)
        ENDIF
      ELSEIF HMG_StrCmp(HB_FNameExt(aFile[n][F_NAME]), ".pdf", .F.) != 0
        HB_aDel(aFile, n, .T.)
      ENDIF
    NEXT

    aSort(aFile, NIL, NIL, ;
          {|a1, a2|
            IF ("D" $ a1[F_ATTR]) .and. (! ("D" $ a2[F_ATTR]))
              RETURN .T.
            ELSEIF (! ("D" $ a1[F_ATTR])) .and. ("D" $ a2[F_ATTR])
              RETURN .F.
            ENDIF
            RETURN (HMG_StrCmp(a1[F_NAME], a2[F_NAME], .F.) < 0)
          })

    HB_aIns(aFile, 1, {"..", 0, "", "", "D"}, .T.)

    nLen := Len(aFile)

    FOR n := 1 TO nLen
      IF "D" $ aFile[n][F_ATTR]
        aFile[n][F_NAME] := "<" + aFile[n][F_NAME] + ">"
      ENDIF

      PdfView.Files.AddItem(aFile[n])

      IF aFile[n][F_NAME] == cFileSel
        nSel := n
      ENDIF
    NEXT
  ENDIF

  EnableWindowRedraw(PdfView.Files.HANDLE, .T., .T.)

  PdfView.Files.VALUE := nSel
  PdfView.Files.ColumnWIDTH(1) := PdfView.Files.WIDTH - 4 - If(PdfView.Files.ITEMCOUNT > SendMessage(PdfView.Files.HANDLE, 0x1028 /*LVM_GETCOUNTPERPAGE*/, 0, 0), GetVScrollBarWidth(), 0)
  PdfView.Files.Header(1) := If(Empty(cFileDir), "Disk", cFileDir)

RETURN NIL


FUNCTION FileOpen(lAtPage)
  LOCAL cFile := PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME)
  LOCAL nPage
  LOCAL lSumatraFocus

  IF Empty(cFile)
    RETURN NIL
  ENDIF

  IF "D" $ PdfView.Files.CellEx(PdfView.Files.VALUE, F_ATTR)
    IF "K" $ PdfView.Files.CellEx(PdfView.Files.VALUE, F_ATTR)
      IF VolSerial(DirSepAdd(cFile)) == -1
        MsgWin(cFile + CRLF + CRLF + "Disk is not available!")
      ELSE
        cFileDir := DirSepAdd(cFile)
        cFile    := ""
      ENDIF
    ELSE
      cFile := HB_USubstr(cFile, 2, HMG_Len(cFile) - 2)

      IF cFile == ".."
        IF HMG_Len(cFileDir) == 3
          cFile := DirSepDel(cFileDir)
        ELSE
          cFile := "<" + HB_FNameNameExt(DirSepDel(cFileDir)) + ">"
        ENDIF
        cFileDir := DirParent(cFileDir)
      ELSE
        cFileDir := DirSepAdd(cFileDir + cFile)
        cFile    := ""
      ENDIF
    ENDIF

    FileListRefresh(cFile)
    RETURN NIL
  ENDIF

  IF HB_IsLogical(lAtPage) .and. lAtPage
    nPage := InputPageNum()

    IF HB_IsNIL(nPage)
      RETURN NIL
    ENDIF
  ENDIF

  IF Sumatra_FrameHandle(cPanel) != 0
    lToolbar := Sumatra_Toolbar(cPanel)

    IF Sumatra_BookmarksExist(cPanel)
      lBookmarks := Sumatra_Bookmarks(cPanel)
    ENDIF
  ENDIF

  lSumatraFocus := (GetFocus() != PdfView.Files.HANDLE)

  nPage := Sumatra_FileOpen(cPanel, cFileDir + cFile, nPage, lBookmarks, lToolbar, "en", If(Empty(cSumatraDir), HB_DirBase(), cSumatraDir) + "SumatraPDF.exe")

  SWITCH nPage
    CASE -1
      MsgWin("Panel window is not defined!")
      EXIT
    CASE -2
      MsgWin(If(Empty(cSumatraDir), HB_DirBase(), DirSepAdd(TrueName(cSumatraDir))) + "SumatraPDF.exe" + CRLF + CRLF + "File does not exist!" + CRLF + "Set path to SumatraPDF.exe.")
      InputSumatraDir()
      EXIT
    CASE -3
      MsgWin(cFileDir + cFile + CRLF + CRLF + "File does not exist!" + CRLF + "List will be refreshed.")
      FileListRefresh("")
      EXIT
    OTHERWISE
      SetFocus(If(lSumatraFocus, Sumatra_FrameHandle(cPanel), PdfView.Files.HANDLE))
      PdfView.TITLE := "PdfView: " + cFile
      PdfView.STATUSBAR.Item(1) := cFileDir + cFile
  ENDSWITCH

RETURN NIL


FUNCTION FileClose()

  IF Sumatra_FrameHandle(cPanel) != 0
    lToolbar := Sumatra_Toolbar(cPanel)

    IF Sumatra_BookmarksExist(cPanel)
      lBookmarks := Sumatra_Bookmarks(cPanel)
    ENDIF
  ENDIF

  Sumatra_FileClose(cPanel, .T.)

  PdfView.TITLE := "PdfView"
  PdfView.STATUSBAR.Item(1) := ""

RETURN NIL


FUNCTION InputPageNum()
  LOCAL nPage

  DEFINE WINDOW InputPage;
    WIDTH  170 + GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/) * 2;
    HEIGHT  74 + GetSystemMetrics(4 /*SM_CYCAPTION*/) + GetSystemMetrics(8 /*SM_CYFIXEDFRAME*/) * 2;
    TITLE  "Open file at page";
    MODAL;
    NOSIZE

    DEFINE LABEL PageNumber
      ROW     13
      COL     30
      WIDTH   70
      HEIGHT  13
      VALUE  "Page number:"
    END LABEL

    DEFINE TEXTBOX Number
      ROW         10
      COL         100
      WIDTH       40
      HEIGHT      21
      VALUE       1
      MAXLENGTH   5
      RIGHTALIGN  .T.
      DATATYPE    NUMERIC
      ONGOTFOCUS  PostMessage(InputPage.Open.HANDLE, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
      ONLOSTFOCUS SendMessage(InputPage.Open.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
      ONENTER     ((nPage := InputPage.Number.VALUE), InputPage.RELEASE)
    END TEXTBOX

    DEFINE BUTTON Open
      ROW     41
      COL     10
      WIDTH   70
      HEIGHT  23
      CAPTION "Open"
      ACTION  ((nPage := InputPage.Number.VALUE), InputPage.RELEASE)
    END BUTTON

    DEFINE BUTTON Cancel
      ROW     41
      COL     90
      WIDTH   70
      HEIGHT  23
      CAPTION "Cancel"
      ACTION  InputPage.RELEASE
    END BUTTON
  END WINDOW

  SendMessage(InputPage.Open.HANDLE, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
  EventCreate({ || If(LoWord(EventWPARAM()) == 2 /*IDCANCEL*/, InputPage.RELEASE, NIL) }, InputPage.HANDLE, 273 /*WM_COMMAND*/)

  InputPage.CenterIn(PdfView)
  InputPage.ACTIVATE

  IF HB_IsNumeric(nPage) .and. (nPage < 1)
    nPage := 1
  ENDIF

RETURN nPage


FUNCTION InputSumatraDir()
  LOCAL cDir

  DEFINE WINDOW InputDir;
    WIDTH  250 + GetSystemMetrics(7 /*SM_CXFIXEDFRAME*/) * 2;
    HEIGHT  74 + GetSystemMetrics(4 /*SM_CYCAPTION*/) + GetSystemMetrics(8 /*SM_CYFIXEDFRAME*/) * 2;
    TITLE  "SumatraPDF directory";
    MODAL;
    NOSIZE

    DEFINE TEXTBOX Dir
      ROW         10
      COL         10
      WIDTH       230
      HEIGHT      21
      VALUE       cSumatraDir
      MAXLENGTH   260
      DATATYPE    CHARACTER
      ONGOTFOCUS  PostMessage(InputDir.OK.HANDLE, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
      ONLOSTFOCUS SendMessage(InputDir.OK.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/,    1)
      ONENTER     ((cDir := InputDir.Dir.VALUE), InputDir.RELEASE)
    END TEXTBOX

    DEFINE BUTTON Browse
      ROW     41
      COL     10
      WIDTH   70
      HEIGHT  23
      CAPTION "&Browse..."
      ACTION  BrowseForSumatraDir()
    END BUTTON

    DEFINE BUTTON OK
      ROW     41
      COL     90
      WIDTH   70
      HEIGHT  23
      CAPTION "OK"
      ACTION  ((cDir := InputDir.Dir.VALUE), InputDir.RELEASE)
    END BUTTON

    DEFINE BUTTON Cancel
      ROW     41
      COL     170
      WIDTH   70
      HEIGHT  23
      CAPTION "Cancel"
      ACTION  InputDir.RELEASE
    END BUTTON
  END WINDOW

  SendMessage(InputDir.OK.HANDLE, 244 /*BM_SETSTYLE*/, 1 /*BS_DEFPUSHBUTTON*/, 1)
  EventCreate({ || If(LoWord(EventWPARAM()) == 2 /*IDCANCEL*/, InputDir.RELEASE, NIL) }, InputDir.HANDLE, 273 /*WM_COMMAND*/)

  InputDir.CenterIn(PdfView)
  InputDir.ACTIVATE

  IF HB_IsString(cDir)
    cSumatraDir := DirSepAdd(cDir)
  ENDIF

RETURN NIL


FUNCTION BrowseForSumatraDir()
  LOCAL cDir := DirSepAdd(TrueName(InputDir.Dir.VALUE))

  SendMessage(InputDir.OK.HANDLE,     244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
  SendMessage(InputDir.Cancel.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)

  IF ! HB_DirExists(cDir)
    cDir := HB_DirBase()
  ENDIF

  cDir := DirSepAdd(C_GetFolder(e"\nSelect SumatraPDF folder:", HB_BitOr(BIF_NEWDIALOGSTYLE, BIF_NONEWFOLDERBUTTON), NIL, NIL, cDir))

  IF ! Empty(cDir)
    InputDir.Dir.VALUE := cDir
    InputDir.Dir.SETFOCUS
    SendMessage(InputDir.Browse.HANDLE, 244 /*BM_SETSTYLE*/, 0 /*BS_PUSHBUTTON*/, 1)
  ENDIF

RETURN NIL


FUNCTION MsgWin(aMsg)
  LOCAL cMsg := ""
  LOCAL nHDC
  LOCAL nHFont
  LOCAL cLine
  LOCAL nLaW, nLaH
  LOCAL nCAW

  IF HB_IsString(aMsg)
    aMsg := HB_aTokens(aMsg, .T. /*lEOL*/)
  ENDIF

  IF IsWindowVisible(GetMainFormHandle())
    DEFINE WINDOW MsgWnd;
      MODAL;
      NOSIZE
  ELSE
    DEFINE WINDOW MsgWnd;
      CHILD;
      NOMINIMIZE;
      NOMAXIMIZE;
      NOSIZE
  ENDIF

    DEFINE LABEL MsgText
      ROW     10
    END LABEL

    DEFINE BUTTON OK
      WIDTH   80
      HEIGHT  23
      CAPTION "OK"
      ACTION  MsgWnd.RELEASE
    END BUTTON
  END WINDOW

  nHDC   := GetDC(MsgWnd.MsgText.HANDLE)
  nHFont := GetWindowFont(MsgWnd.MsgText.HANDLE)
  nLaW   := 100

  FOR EACH cLine IN aMsg
    nLaW := Max(nLaW, GetTextWidth(nHDC, cLine, nHFont))
    cMsg += cLine + CRLF
  NEXT

  nLaH := GetTextHeight(nHDC, aMsg[1], nHFont) * Len(aMsg)

  ReleaseDC(MsgWnd.HANDLE, nHDC)

  nCAW := nLaW + 20

  MsgWnd.WIDTH  := nCAW + (MsgWnd.WIDTH - MsgWnd.CLIENTAREAWIDTH)
  MsgWnd.HEIGHT := nLaH + 53 + (MsgWnd.HEIGHT - MsgWnd.CLIENTAREAHEIGHT)
  MsgWnd.TITLE  := "PdfView"

  MsgWnd.MsgText.COL     := Int((nCAW - nLaW) / 2)
  MsgWnd.MsgText.WIDTH   := nLaW
  MsgWnd.MsgText.HEIGHT  := nLaH
  MsgWnd.MsgText.CAPTION := cMsg

  MsgWnd.OK.ROW := nLaH + 20
  MsgWnd.OK.COL := Int((nCAW - 80) / 2)

  C_Center(MsgWnd.HANDLE, GetActiveWindow())
  EventCreate({ || If(LoWord(EventWPARAM()) == 2 /*IDCANCEL*/, MsgWnd.RELEASE, NIL) }, MsgWnd.HANDLE, 273 /*WM_COMMAND*/)

  MsgWnd.ACTIVATE

RETURN NIL

FUNCTION IsProgramRunning()
  LOCAL cCurProcName := HMG_Upper(GetProgramFileName())
  LOCAL nCurProcID   := GetCurrentProcessId()
  LOCAL aProcID      := EnumProcessesID()
  LOCAL nPID
  LOCAL aHWnd
  LOCAL nWinPID
  LOCAL nHMainWnd
  LOCAL n

  FOR n := 1 TO Len(aProcID)
    IF (HMG_Upper(GetProcessFullName(aProcID[n])) == cCurProcName) .and. (aProcID[n] != nCurProcID)
      nPID := aProcID[n]
      EXIT
    ENDIF
  NEXT

  IF HB_IsNumeric(nPID)
    aHWnd := EnumWindows()

    FOR n := 1 TO Len(aHWnd)
      //IF (HMG_Upper(HB_ULeft(GetClassName(aHWnd[n]), 13)) == "_HMG_PDFVIEW_")
      IF IsWindowVisible(aHWnd[n]) .and. (! Empty(GetWindowText(aHWnd[n])))
        GetWindowThreadProcessId(aHWnd[n], NIL, @nWinPID)

        IF nWinPID == nPID
          nHMainWnd := aHWnd[n]
          EXIT
        ENDIF
      ENDIF
    NEXT

    IF HB_IsNumeric(nHMainWnd)
      IF IsMinimized(nHMainWnd)
        Restore(nHMainWnd)
      ELSE
        SetForegroundWindow(nHMainWnd)
      ENDIF
    ELSE
      MsgWin("Program already is running!")
    ENDIF
  ENDIF

RETURN HB_IsNumeric(nPID)


FUNCTION SettingsRead()
  LOCAL aLine := HB_aTokens(HB_MemoRead(HB_fNameExtSet(GetProcessFullName(), "ini")), CRLF)
  LOCAL cLine
  LOCAL nPos
  LOCAL cValue

  lPdfView_Max := .F.
  nPdfView_R   := 100
  nPdfView_C   := 100
  nPdfView_W   := 650
  nPdfView_H   := 450
  nFiles_W     := 150
  lBookmarks   := .T.
  lToolbar     := .F.
  lOpenAtOnce  := .F.
  lEscExit     := .F.
  cSumatraDir  := ""
  cFileDir     := HB_CWD()
  cFileLast    := ""
  cLang        := "en"

  FOR EACH cLine IN aLine
    cLine := AllTrim(cLine)
    nPos  := HB_UAt("=", cLine)

    IF nPos > 0
      cValue := HB_USubstr(cLine, nPos + 1)

      SWITCH HB_ULeft(cLine, nPos - 1)
        CASE "PdfView_Max" ; lPdfView_Max := (cValue == "T") ; EXIT
        CASE "PdfView_R"   ; nPdfView_R   := Val(cValue)     ; EXIT
        CASE "PdfView_C"   ; nPdfView_C   := Val(cValue)     ; EXIT
        CASE "PdfView_W"   ; nPdfView_W   := Val(cValue)     ; EXIT
        CASE "PdfView_H"   ; nPdfView_H   := Val(cValue)     ; EXIT
        CASE "Files_W"     ; nFiles_W     := Val(cValue)     ; EXIT
        CASE "Bookmarks"   ; lBookmarks   := (cValue == "T") ; EXIT
        CASE "Toolbar"     ; lToolbar     := (cValue == "T") ; EXIT
        CASE "OpenAtOnce"  ; lOpenAtOnce  := (cValue == "T") ; EXIT
        CASE "EscExit"     ; lEscExit     := (cValue == "T") ; EXIT
        CASE "SumatraDir"  ; cSumatraDir  := cValue          ; EXIT
        CASE "FileDir"     ; cFileDir     := cValue          ; EXIT
        CASE "FileLast"    ; cFileLast    := cValue          ; EXIT
        CASE "Lang"        ; cLang        := cValue          ; EXIT
      ENDSWITCH
    ENDIF
  NEXT

  IF nPdfView_W < 400
    nPdfView_W := 400
  ENDIF

  IF nPdfView_H < 300
    nPdfView_H := 300
  ENDIF

  IF nFiles_W < 100
    nFiles_W := 100
  ENDIF

  cSumatraDir := DirSepAdd(cSumatraDir)

  IF ! Empty(cFileDir)
    IF (VolSerial(HB_ULeft(cFileDir, 3)) == -1) .or. (! HB_DirExists(cFileDir))
      cFileDir := HB_CWD()
    ELSE
      cFileDir := DirSepAdd(cFileDir)
    ENDIF
  ENDIF

  HB_CWD(HB_DirBase())

  cLang := HMG_Lower(cLang)
  IF ! (cLang == "pl")
    cLang := "en"
  ENDIF

RETURN NIL


FUNCTION SettingsWrite()
  LOCAL aWndPos := GetWindowNormalPos(PdfView.HANDLE)
  LOCAL cText

  IF Sumatra_FrameHandle(cPanel) != 0
    lToolbar := Sumatra_Toolbar(cPanel)

    IF Sumatra_BookmarksExist(cPanel)
      lBookmarks := Sumatra_Bookmarks(cPanel)
    ENDIF
  ENDIF

  cText := "PdfView_Max=" + If(PdfView.ISMAXIMIZED, "T", "F") + CRLF + ;
           "PdfView_R="   + HB_NtoS(aWndPos[2]) + CRLF + ;
           "PdfView_C="   + HB_NtoS(aWndPos[1]) + CRLF + ;
           "PdfView_W="   + HB_NtoS(aWndPos[3] - aWndPos[1]) + CRLF + ;
           "PdfView_H="   + HB_NtoS(aWndPos[4] - aWndPos[2]) + CRLF + ;
           "Files_W="     + HB_NtoS(PdfView.Files.WIDTH) + CRLF + ;
           "Bookmarks="   + If(lBookmarks, "T", "F") + CRLF + ;
           "Toolbar="     + If(lToolbar, "T", "F") + CRLF + ;
           "OpenAtOnce="  + If(lOpenAtOnce, "T", "F") + CRLF + ;
           "EscExit="     + If(lEscExit, "T", "F") + CRLF + ;
           "SumatraDir="  + cSumatraDir + CRLF + ;
           "FileDir="     + cFileDir + CRLF + ;
           "FileLast="    + PdfView.Files.CellEx(PdfView.Files.VALUE, F_NAME) + CRLF + ;
           "Lang="        + cLang + CRLF

  HB_MemoWrit(HB_fNameExtSet(GetProcessFullName(), "ini"), cText)

RETURN NIL


FUNCTION DirSepAdd(cDir)

  IF (! Empty(cDir)) .and. (! (HB_URight(cDir, 1) == "\"))
    cDir += "\"
  ENDIF

RETURN cDir


FUNCTION DirSepDel(cDir)

  IF HB_URight(cDir, 1) == "\"
    cDir := HB_StrShrink(cDir)
  ENDIF

RETURN cDir


FUNCTION DirParent(cDir)

  cDir := DirSepDel(cDir)

RETURN HB_ULeft(cDir, HB_UTF8RAt("\", cDir))

